/****************************************************************************************/

#ifndef __MORPHOS__

#include "filereq.h"

/****************************************************************************************/

APTR REGARGS AllocVecPooled (APTR pool, ULONG memsize)
{
    if (pool)
    {
	IPTR *mem;

	memsize += sizeof(IPTR);

	if ((mem = AllocPooled(pool, memsize)))
	{
	    *mem++ = memsize;
	}

	return mem;
    }
    else
    {
        return rtAllocVec(memsize, MEMF_PUBLIC | MEMF_CLEAR);
    }
}

/****************************************************************************************/

void REGARGS FreeVecPooled (APTR pool, APTR mem)
{
    if (mem)
    {
	if (pool)
	{
	    IPTR *imem = (IPTR *)mem;
	    IPTR size = *--imem;
 
	    FreePooled(pool, imem, size);
        }
	else
	{
             rtFreeVec(mem);
	}
    }
}

#endif /* !__MORPHOS__ */

/****************************************************************************************/

